/*
** hook_asc.s
**
** Part of Preview SMS
** Copyright (c) 2007 NuukiaWorld
**
**  RPN calculator is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

@ Note: This version of hooks are used only with ASCII-based SMS editor

.global hook_menu
.global hook_menu_code
.global hook_ui
.global hook_ui_code

@ This hook adds the Preview item in the send sms menu
@ Hooking method allows co-existence with send_flash_sms
hook_menu:

push {r7,lr}
mov  r7,r0              @ menu id

hook_menu_code:
nop                     @ here is "Send" (and "Send as flash") added to the menu
nop

mov  r0,r7
mov  r1,#2
ldr  r2,_item_preview
bl   menu_add_item      @ here we add our own "Preview" to the menu

pop  {r7,pc}

@ This hook catches our custom message and activates the preview
hook_ui:

push {lr}

ldr  r1,_msg_1e08
cmp  r0,r1
bne  end

ldr  r1,_dialog_preview
ldr  r0,_write_sms_buffer
bl   dialog_open        @ the dialog action will take care of closing
mov  r0,#0xdc           @ destroy our custom messages after processing

end:
hook_ui_code:
nop
nop

pop  {pc}


.align

_item_preview:
.long item_preview

_msg_1e08:
.long 0x1e08

_dialog_preview:
.long dialog_preview

_write_sms_buffer:
.long write_sms_buffer

