/*
** hook_ucs.s
**
** Part of Preview SMS
** Copyright (c) 2007 NuukiaWorld
**
**  RPN calculator is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

@ Note: This version of hooks are used only with UCS-2-based SMS editor

.global hook_menu
.global hook_menu_code
.global hook_ui
.global hook_ui_code

@ This hook adds the Preview item in the send sms menu
@ Hooking method allows co-existence with send_flash_sms
hook_menu:

push {r7,lr}
mov  r7,r0              @ menu id

hook_menu_code:
nop                     @ here is "Send" (and "Send as flash") added to the menu
nop

mov  r0,r7
mov  r1,#2
ldr  r2,_item_preview
bl   menu_add_item      @ here we add our own "Preview" to the menu

pop  {r7,pc}

@ This hook catches our custom message and activates the preview
hook_ui:

push {lr}

ldr  r1,_msg_1e06
sub  r1,r0,r1
beq  preview_send
cmp  r1,#1
beq  preview_close
cmp  r1,#2
bne  end

ldr  r0,_write_sms_buffer  @ backup the word just before write_sms_buffer
ldr  r2,_global_buffer
ldrh r1,[r0]
strh r1,[r2]
ldr  r1,_wcsmark           @ put a 0x04FF in place of it
strh r1,[r0]

ldr  r1,_dialog_preview
bl   dialog_open
b    done

preview_send:              @ 0x1e06 - Send pressed in preview
ldr  r0,_msg_c31
bl   send_message          @ initiate sending with 0xc31
b    close

preview_close:             @ 0x1e07 - Back pressed in preview
ldr  r0,_msg_d_quit_now
bl   send_message

close:
bl   dialog_close          @ the dialog must be closed on these new phones!
ldr  r1,_global_buffer     @ restore backup
ldr  r2,_write_sms_buffer
ldrh r0,[r1]
strh r0,[r2]

done:
mov  r0,#0xdc              @ destroy our custom messages after processing

end:
hook_ui_code:
nop
nop

pop  {pc}


.align

_item_preview:
.long item_preview

_msg_1e06:
.long 0x1e06

_global_buffer:
.long global_buffer

_write_sms_buffer:
.long write_sms_buffer-2

_wcsmark:
.long 0x04ff

_dialog_preview:
.long dialog_preview

_msg_c31:
.long 0xc31

_msg_d_quit_now:
.long 0x5e7

